# -*- coding: utf-8 -*-
# Moovida - Home multimedia server
# Copyright (C) 2009 Fluendo Embedded S.L. (www.fluendo.com).
# All rights reserved.
#
# This file is available under one of two license agreements.
#
# This file is licensed under the GPL version 3.
# See "LICENSE.GPL" in the root of this distribution including a special
# exception to use Moovida with Fluendo's plugins.
#
# The GPL part of Moovida is also available under a commercial licensing
# agreement from Fluendo.
# See "LICENSE.Moovida" in the root directory of this distribution package
# for details on that license.
#
# Author: Jes�s Corrius i Llavina <jcorrius@fluendo.com>

from elisa.plugins.database.actions import MoreOptionsAction
from elisa.plugins.poblesec.actions import OpenControllerAction


class OpenJamendoControllerAction(OpenControllerAction):
    def execute(self, item):
        return self.open_controller(self.path, item.title, jamendo_model=item)


class ListJamendoAlbumTracksAction(OpenControllerAction):
    name = 'list'
    
    def __init__(self, controller):
        path = '/poblesec/jamendo/album/list'
        return super(ListJamendoAlbumTracksAction, self).__init__(controller, 
                                                                  path)

    def execute(self, item):
        return self.open_controller(self.path, item.name, album=item)


class JamendoAlbumMoreOptionsAction(MoreOptionsAction):
    path = '/poblesec/jamendo/album/more'

    def execute(self, item):
        return self.open_controller(self.path, item.name, album=item)


class ListJamendoArtistAlbumsAction(OpenControllerAction):
    def __init__(self, controller):
        path = '/poblesec/jamendo/albums'
        return super(ListJamendoArtistAlbumsAction, self).__init__(controller, 
                                                                   path)

    def execute(self, item):
        return self.open_controller(self.path, item.name, jamendo_model=item)

class JamendoArtistMoreOptionsAction(MoreOptionsAction):
    path = '/poblesec/jamendo/artist/more'

    def execute(self, item):
        return self.open_controller(self.path, item.name, artist=item)
